
var poplingPrefs;
var navToTab;
var global_timeout = 10000;

var parentBridge = {};

//prefs specific
parentBridge.getPrefs = getPrefs;
parentBridge.setPrefs = setPrefs;
parentBridge.setPass = setPass;
parentBridge.getPass = getPass;
parentBridge.getUser = getUser;
parentBridge.poplingPrefs = poplingPrefs;
parentBridge.getRunAtStartup = getRunAtStartup;
parentBridge.setRunAtStartup = setRunAtStartup;
parentBridge.setPrefs = setPrefs;
parentBridge.changeClass = changeClass;


//debug
parentBridge.trace = trace;

//card specific 
parentBridge.getRemoteURL = getRemoteURL;
parentBridge.renderNotifyWindow = renderNotifyWindow;

//core specific
parentBridge.linkToPage = linkToPage;
parentBridge.startTimer = startTimer;
parentBridge.turnOn = turnOn;
parentBridge.turnOff = turnOff;
parentBridge.show = showFullWindow;
parentBridge.hider = hider;
parentBridge.loadURLAndReturnVars = loadURLAndReturnVars;
parentBridge.showCloseWarning = showCloseWarning;
parentBridge.closeWindow = closeWindow;
parentBridge.reloadApp = reloadApp;
parentBridge.setConn = setConn;

//update
parentBridge.getAirFile = getAirFile;
parentBridge.updateVersionViewed = updateVersionViewed;
parentBridge.getVersionViewed = getVersionViewed;
parentBridge.getThisVersion = getThisVersion;


function bridge(){
	document.getElementById('UI').contentWindow.parentSandboxBridge = parentBridge;
	
	//PULLS SANDBOX FUNCTIONS INTO MAIN APP
	//create some vars for the sandbox to use to refrence bridged functions
	
	var csbb =				 		document.getElementById('UI').contentWindow.childSandboxBridge;
	navToTab =						csbb.navToTab;
	clearCard = 					csbb.clearCard;
	getCard = 						csbb.getCard;
	makeRetrievedCard = 			csbb.makeRetrievedCard;
	displayOfflineMessage = 		csbb.displayOfflineMessage;
	getCardState = 					csbb.getCardState;
	initPopUI = 					csbb.initPopUI;
	displayVersionCheckMessage = 	csbb.displayVersionCheckMessage;
	displayUpgradeMessage = 		csbb.displayUpgradeMessage;
	getRetrievedCard = 				csbb.getRetrievedCard;
	getCurrentTab = 				csbb.getCurrentTab;
	getAuxContent = 				csbb.getAuxContent;
	isPro = 						csbb.isPro;
}

function waitForSandboxLoad(){
	//fix for xttp object has to be called after complete load.
	//function is called by an interval in initPopling
	
	if(initPopUI != "undefined"){
		clearInterval(init_interval);
		getAppVersion(); //ends in calling continueInitializing and passing true or false on whether to get a new app version
		
	}
}

function continueInitializing(newAppVersion){ //called by parseVersion in update.js
	
	getPrefs();
	
	initConnectionManager();
	
	makeFull();
	initPopUI(newAppVersion);
	
	$('#hide_button').show();	
	changeClass(poplingPrefs['style']);
}

function initPopling(){
	trace("initPopling");
	
	logger = new AIRLogger();
	
	createWindowListeners();
	dockSystrayInvoke();
	bridge();
	
	//zapPrefs();

	init_interval =  setInterval(waitForSandboxLoad,1000);
}


