// JavaScript Document
var currentTab;
var thisVersion;
var global_timeout = 10000;

function getAdURL(){
   var url = 'http://www.amazon.com/gp/product/0764179845?ie=UTF8&tag=popling-20&linkCode=as2&camp=1789&creative=9325&creativeASIN=0764179845';
   parentSandboxBridge.linkToPage(url);		
}


function changeClass(c){
	parentSandboxBridge.trace('changeClass sb ' + c);
	$('body').removeClass();
	$('body').addClass(c);
}


function navToTab(t){
	
	if(t=='cards'){
		parentSandboxBridge.turnOn();
	}else if(t!='offlineMessage' && t!= 'offlineMessage'){	
		parentSandboxBridge.turnOff();
	}
	
	document.getElementById('cards').style.display = 'none';
	document.getElementById('prefs').style.display = 'none';
	document.getElementById('confirm').style.display = 'none';
	document.getElementById('flag_card').style.display = 'none';
	document.getElementById('twitt').style.display = 'none';
	document.getElementById('main_messages').style.display = 'none';
	document.getElementById('offlineMessage').style.display = 'none';
	
	document.getElementById(t).style.display = 'inline';
	
	if(t == "prefs"){
		$('#message').hide();
		renderPreferences();
	}else if(t == 'twitt'){
		suggestTwitterStatus();
	}else if(t == 'cards'){
		getCard();
	
	}
	
	currentTab = t;
	
}

function suggestTwitterStatus(){
	var q = retrievedCard.q;
	var p = retrievedCard.p;
	$('#twitterStatus').val("@popling Having trouble learning "+ p.category +" "+ q.question +" = "+ q.correct);
}

function postToTwitter(){
	//if(c){
	
	var u = remoteUrl + "air/twit.php";
	
	var d = "status="+$("#twitterStatus").val();
	d += "&u="+$("#t_username").val();
	d += "&p="+$("#t_password").val();
	
	
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			
			parentSandboxBridge.trace("posted to twitter: "+data);
			navToTab('cards');
			
	   },
	   error: ajax_timeout_error

	 });
		
}

function displayTwitterUpdateError(){
	
	$("#twitterError").text("Error updating Twitter status.");
	$("#twitterError").show();
}

function getCurrentTab(){
	return currentTab;
}

//KEY ACTIONS
//Handles keyboard shortcuts for hiding, return key for next card, 
//return key for submit answer, etc.
function keyPressEvent(e){
	if(e.keyCode == 119 && e.metaKey || e.keyCode == 119 && e.altKey){ //hide on cntrl w press
		hider();
	}else if (e.keyCode == 13 && cardState == "question-reten"){ //hide on cntrl w press
		submitAnswer();
	}
}

document.onkeypress=keyPressEvent;

function continueFromFeatures(){
	parentSandboxBridge.updateVersionViewed(thisVersion);
	navToTab('cards');	
}


function initPopUI(newAppVersion){
	
	parentSandboxBridge.trace("initPopUI");
	prefs_sb = 	parentSandboxBridge.getPrefs();
	
	if(newAppVersion){
		displayUpgradeMessage();
	}else{
		if(prefs_sb['name'] == ''){ //this is the first run, display message
			navToTab('prefs');
			displayNewUserMessage();
		}else{
			username = 	parentSandboxBridge.getUser();
			password = 	parentSandboxBridge.getPass(true);
			remoteUrl = parentSandboxBridge.getRemoteURL();
			
			//has the user viewed the version notes?
			var vv = parentSandboxBridge.getVersionViewed();
			thisVersion = parentSandboxBridge.getThisVersion();
		
			if(vv != thisVersion){
				displayNewFeatures();
			}else{
				navToTab('cards');
			}
		}
	}
	
	changeClass(prefs_sb['style']);
}


function resetPassLink(){
	var url = "http://popling.net/signup/get_password.php";
	parentSandboxBridge.linkToPage(url);
}


function getUpdate(){

	//start download
	parentSandboxBridge.getAirFile();
	
	//update status message
	var statusMessage = "<img src='assets/images/progress.gif' /> Downloading Update...";
	document.getElementById("update_mess").innerHTML = statusMessage;
}

//////////////////////////////////////
//LINKS
//////////////////////////////////////

function getPoplingsLink(){
	var url = remoteUrl + "poplings";	
	parentSandboxBridge.linkToPage(url);
}


function goToCurrentOutsideLink(){
	parentSandboxBridge.linkToPage(currentOutsideLink);
}


function getSupportLink(){
	var url = "http://www.getsatisfaction.com/popling";	
	parentSandboxBridge.linkToPage(url);
}

function contactPopling(){
	var url = "http://www.popling.net/about/contact.php";	
	parentSandboxBridge.linkToPage(url);
}



//////////////////////////////////////
//Poptool buttons
//////////////////////////////////////


function deleteFromBanked() { 
	manageList("banked","delete"); 
}

function addToBanked() { 
	manageList("banked","add"); 
}

function create_banked_ListB(onList){
	if(onList == true){
		document.getElementById("deleteEasy").style.display="inline";
		document.getElementById("addEasy").style.display="none";
	}else{
		
		document.getElementById("deleteEasy").style.display="none";
		document.getElementById("addEasy").style.display="inline";
	} 
	
}

function create_hardlist_ListB(onList){
	if(onList == true){
		document.getElementById("deleteHard").style.display="inline";
		document.getElementById("addHard").style.display="none";
	}else{
		
		document.getElementById("deleteHard").style.display="none";
		document.getElementById("addHard").style.display="inline";
	} 
}


function manageList(list,action){
	//parentSandboxBridge.trace("managing "+list+" action is " +action);
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	
	var u = remoteUrl + "air/lists.php";
	var d = "popling_id="+p.popling_id;
	
	d += "&q_id="+q.q_id;
	d += "&list="+list;
	d += "&u="+username;
	d += "&p="+MD5(password);
	d += "&"+action+"=1";
	
	//parentSandboxBridge.trace("manage lists: "+u+d);
	
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			//parentSandboxBridge.trace("manageList: updated: "+data);
			
			if(action == "add"){
				l = list;
			}else{
				l = "fulllist";
			}
			if(list == "banked"){
				if(action == "add"){
					create_banked_ListB(true);
				}else{
					create_banked_ListB(false);
				}
			}else{
				//hard list
				if(action == "add"){
					create_hardlist_ListB(true);
				}else{
					create_hardlist_ListB(false);
				}
			}
			
	   },  error: ajax_timeout_error

	 });
		
}


function unsubscribe(){
	
	//var c = confirm("Are you sure you would like to unsubscribe from this Popling?"); 	
	//if(c){
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	var u = remoteUrl + "air/unsub.php";
	d = "popling_id="+p.popling_id;
	d += "&u="+username;
	d += "&p="+MD5(password);
	
	//parentSandboxBridge.trace("unsubscribing: " + u + d);
		
	
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			
			var r = JSON.parse(data);
			//parentSandboxBridge.trace("unsubscribed: "+data);
			resetRetrievedCard();
			getCard();
			
	   },
	   error: ajax_timeout_error

	 });
		
}



///////////////////////////////////////
// FLAG UI
//////////////////////////////////////
function getCheckedValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}

function sendFlag(){
	var o = document.forms['flag_radio_form'].elements['flag_card'];
	var v = getCheckedValue(o);
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	var u = remoteUrl + "air/flag.php";
	
	var d = "popling_id="+p.popling_id;
	d += "&q_id="+q.q_id;
	d += "&flag="+v;
	d += "&u="+username;
	d += "&p="+MD5(password);
	//parentSandboxBridge.trace("send flag"+u);
	
	
		
		
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			//parentSandboxBridge.trace("Flag Sent: "+data);
			showFlagResponse();

	   },
	  error: ajax_timeout_error

	 });
		
	
}

function showFlagResponse(){
	document.getElementById("flaggit").style.display = "none";
	document.getElementById("flag_response").style.display = "inline";
}


function flagContinue(){
	document.getElementById('flaggit').style.display = 'inline';
	document.getElementById('flag_response').style.display = 'none';
	navToTab("cards");
}
//end flag


///////////////////////////////////////
// END PREFERENCES UI
//////////////////////////////////////

function bridgeChild(){
	//make these functions availabe to the parent
	childSandboxBridge = {
		'initPopUI'						:	initPopUI,
		'navToTab'						:	navToTab,
		'clearCard'						:	clearCard,
		'getCard'						:	getCard,
		'getCardState'					:	getCardState,
		'makeRetrievedCard'				:	makeRetrievedCard,
		'displayOfflineMessage'			: 	displayOfflineMessage,
		'displayUpgradeMessage'			:	displayUpgradeMessage,
		'displayVersionCheckMessage'	:	displayVersionCheckMessage,
		'getRetrievedCard'				:	getRetrievedCard,
		'getCurrentTab'					:	getCurrentTab,
		'getAuxContent'					:	getAuxContent,
		'isPro'							:	isPro
	};
}

function initUI(){
	bridgeChild();
}