// -----------------------------------------------------------------------------------
//
//	AIRLogger v1.0
//	by Mark Rickert - http://www.ear-fung.us
//	Last Modification: 2008/08/15
//
//	For more information, visit:
//	http://www.ear-fung.us/apps/airlogger/
//
//	Licensed under the Creative Commons Attribution 3.0 License - http://creativecommons.org/licenses/by/3.0/
//  	- Free for use in both personal and commercial projects
//		- Attribution requires leaving author name, author link, and the license info intact.
//
// -----------------------------------------------------------------------------------

var logger = null;


//var AIRLogger = Class.create();

AIRLogger = function (){
		this.log_file = air.File.desktopDirectory.resolvePath( 'popling_log.txt' );
		this.log_stream  = new air.FileStream();
}
	
writeLog = function(log_text) {
	this.log_stream.open( this.log_file, air.FileMode.APPEND );
	this.log_stream.writeMultiByte(
			this.dateTime() + " -" + 
			" air:" + air.Capabilities.version + 
			" os:" + air.Capabilities.os + 
			" mem:" + air.System.totalMemory + 
			" txt:" + log_text + 
			"\n", air.File.systemCharset );
	this.log_stream.close();
}
	
clearLog = function() {
	this.log_stream.open( this.log_file, air.FileMode.WRITE );
	this.log_stream.writeMultiByte("", air.File.systemCharset );
	this.log_stream.close();
}
	
dateTime = function(){
		var currentDate = new Date();
		return currentDate.toLocaleString();
}

AIRLogger.prototype.writeLog = writeLog;
AIRLogger.prototype.clearLog = clearLog;
AIRLogger.prototype.dateTime = dateTime;




