// JavaScript Document

var cardState;
var remoteUrl;
var prefsUrl;
var editQUrl;
var trace;
var hider;
var username;
var password;
var retrievedCard = null;
var cardIsAnswered = true;
var currentOutsideLink;
var int_test = null;
var currentc;
var user;
var popling_root = this;


function getCardState(){
	return cardState;
}

function getRetrievedCard(){
	if(cardIsAnswered == false && typeof retrievedCard != 'undefined'){
		return retrievedCard;
	}else{
		return null;	
	}
}

function resetRetrievedCard(){
	retrievedCard = null;
}

function html_entity_decode(str) {
  var ta=document.createElement("textarea");
  str = str.replace(/</g,"&lt;");
  str = str.replace(/>/g,"&gt;");
  ta.innerHTML=str;
  return ta.value;
}


function clearCard(){
	var card = '<h2>Waiting For Pop</h2>';
	card += '<button id="refresh_card" class="button_a">Refresh</button>'; 
	document.getElementById("card").innerHTML = card;
	var g = document.getElementById("refresh_card");
	g.addEventListener('click',getCard);	
	
}

function displayGettingMessage(){
	var card = '<h2><img src="assets/images/loader.gif" alt="loader" width="32" height="32" align="absmiddle" />';
	card += '<strong class="brightBlue">Getting Card...</strong></h2>';
	document.getElementById("card").innerHTML = card;
}


function getCard(notify){
	//parentSandboxBridge.trace("getCard notify:" + notify);
	//change card to getting message
	if(typeof notify != "undefined"){
		//changes card content to Getting Card
		displayGettingMessage();
	}
	 
	var u = remoteUrl + "air/get.php";
	var passMd5 = MD5(password); 
	var d = "u="+username;
	 	d += "&p="+passMd5;
	 
	 //parentSandboxBridge.trace("getting card: "+u + "?" + d);
	 
	 
	  $.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			
			//parentSandboxBridge.trace("retrieved card:  "+data);
			var r = JSON.parse(data);
			if(r.error == 0){
				retrievedCard = r;
				user = retrievedCard.u;
				
				proSetup();
		
				cardIsAnswered = false;
				
				makeCard();
					
				if(notify == true){
					parentSandboxBridge.renderNotifyWindow();
				}
			}else{
				handleError(r.error);
			}
	   },
	   error: ajax_timeout_error

	 });
	
}

function ajax_timeout_error(){
	//parentSandboxBridge.trace("timeout_getting_card");
	//parentSandboxBridge.setConn(false);
	navToTab('offlineMessage');
	
}

function isPro(){
	return user.pro;
}



function handleError(error){
	
	//specific error code handling
	if(error.code == 1){
		navToTab('prefs');
		displayUserPassWarning();
	} else if(error.code == 2){
		
		document.getElementById("poplingName").innerHTML = "No Subscriptions Found";
		var card ='<strong>'+ error.message +'</strong>';
		card += '<p>You may need to <a href="#" id="getPoplingLink">subscribe to a Popling on the website</a>.</p>';
		card += '<p><button id="refreshCardB">Refresh</button></p>';
		
		document.getElementById("card").innerHTML = card;
		
		var g = document.getElementById("getPoplingLink");
		g.addEventListener('click',getPoplingsLink);	
		
		var b = document.getElementById("refreshCardB");
		b.addEventListener('click',getCard);
	}else{
		document.getElementById("card").innerHTML = card;
	}
	
}

function goToPopling(){
	var popling_id = retrievedCard.p.popling_id;
	var url = remoteUrl + "poplings/view_popling.php?popling_id="+popling_id;
	parentSandboxBridge.linkToPage(url);
}

function containsSpecialChar(){
	var q = retrievedCard.q;
	var c = removePunctuation(q.correct,1,1);
	if(c != q.correct){
		return true;
	}
}


function makeRetrievedCard(){
	parentSandboxBridge.trace("makeRetrievedCard");
	makeCard();
}

function setCopyright(){
	var doLink = false;
	if(retrievedCard.p.copyright != '0' ){
		var cw = retrievedCard.p.copyright;
		parentSandboxBridge.trace("cw: "+cw);
		if(cw != ''){
			var ct = copyrights[cw]['title'];
			var c = "Licensed as: " + ct + ' | ';
		}else{
			c = '';		
		}
	}else{
		c = '';	
	}
	//link
	if(retrievedCard.p.url != '' ){
		var u = retrievedCard.p.url;
		currentOutsideLink = u;
		var d = parseUri(u);
		var l = "Link: <a href='#' id='card_url'>" + d['host']+"</a><img src='assets/images/exLink.gif'  class='exLink' />";
	
		doLink = true;
	}else {
		var l = '';	
	}
	document.getElementById("copy_disp").innerHTML = c + l;
	
	//add click action
	if(doLink){
		var linkButton = document.getElementById("card_url");
		linkButton.addEventListener("click",goToCurrentOutsideLink);
	}
}

function setPopTools(){
	
	var popling_id = retrievedCard.p.popling_id;
	var q_id = retrievedCard.q.q_id;
	var u = retrievedCard.u;
	var l = retrievedCard.l;
	
	prefsUrl = remoteUrl +  "poplings/set_prefs.php?popling_id="+popling_id;
	if(u.permission == 1){
		editQUrl = remoteUrl + "poplings/make_question.php?popling_id=" + popling_id + "&q_id="+q_id;
	}else{
		document.getElementById("editQB").style.display = "none";
	}
	//easy and hardlist button creation
	if(l == "banked"){
		create_banked_ListB(true);
		create_hardlist_ListB(false);
	}else if(l == "hardlist"){
		create_banked_ListB(false);
		create_hardlist_ListB(true);
	}else{
		create_banked_ListB(false);
		create_hardlist_ListB(false);
	}
}

function showLargeImage(){
	parentSandboxBridge.trace("showimage large ");
	var q = retrievedCard.q;
	
	var i_url = remoteUrl +"q_images/"+ q.img_name +"."+q.img_ext;
	$("#largeImage").attr('src',i_url);
	$("#large_imageContain").show();
}

function hideLargeImage(){
	$("#large_imageContain").hide();
}

function makeCard(){
	var q = retrievedCard.q;
	var p = retrievedCard.p;
	
	var cardType = retrievedCard.r; 
	
	parentSandboxBridge.trace("make card - cardType: "+cardType);
	//popling
	document.getElementById("poplingName").innerHTML = "<a href='#' id='poplingLink'>"+p.name+"</a>";
	document.getElementById("poplingLink").addEventListener('click',goToPopling);
		
	var card = "";
	
	if(q.img_name != '' && typeof q.img_name != "undefined"){
		
		var i_thb_url = remoteUrl +"q_images/"+ q.img_name +"_thmb."+q.img_ext;
		
		card += "<div>";
		card += "	<div class='imageContain'>";
		card += "		<img src="+i_thb_url+" id='image_thumb'  border='1' />";
		card += "	</div>";
		card += "	<div  class='imageCardContain'>";
		
		parentSandboxBridge.trace("i_thb_url: "+i_thb_url);
	}
	
	if(cardType == 0 || cardType == null){
		parentSandboxBridge.trace("make card - display or flash");
		//display or flash cards
		cardState = "question-display";
	
	
		
		if(p.q_type == 3){
			card += "<h2 class='question'>"+q.question+"</h2>";
			//display card only, no answer card
			card += '<input class="button_a" type="button" value="Next Card" id="nextCard_b" />';
				
			if(q.img_name != ''  && typeof q.img_name != 'undefined'){
				card += "	</div>";
				card += "	<br style='clear:both' />";
				card += "</div>";
				
			}
	
			document.getElementById("card").innerHTML = card;
			
			if(q.img_name != ''  && typeof q.img_name != 'undefined'){
				var imageThumb = document.getElementById('image_thumb');
				imageThumb.addEventListener("click",showLargeImage);
			}
			
			var nextButton = document.getElementById('nextCard_b');
			nextButton.addEventListener("click",skipCard);
			document.getElementById("nextCard_b").focus();
			parentSandboxBridge.trace("makeCard: focus");
		}else{
			parentSandboxBridge.trace("make card - p q_type: " +q.question + " " +  q.correct);
			//regular flash card, but the first time viewed!
			card += "<h2 class='question'>"+q.question + " = <strong>" + q.correct+"</strong></h2>";
			
			card += '<input class="button_a" type="button" value="Next Card" id="nextCard_b" />';
			
			if(q.img_name != ''  && typeof q.img_name != 'undefined'){
				card += "	</div>";
				card += "	<br style='clear:both' />";
				card += "</div>";
			}
	
	
			document.getElementById("card").innerHTML = card;
			
			if(q.img_name != ''  && typeof q.img_name != 'undefined'){
				var imageThumb = document.getElementById('image_thumb');
				imageThumb.addEventListener("click",showLargeImage);
			}
			
			var nextButton = document.getElementById('nextCard_b');
			nextButton.addEventListener("click",function(){submitScore(2,0,true);});
			
			document.getElementById("nextCard_b").focus();
			parentSandboxBridge.trace("makeCard: focus");
			
		//}else{
			//regular flash card, no retention, not the first time viewed
			/*
			card += '<input class="button_a" type="button" value="Reveal Answer" id="reveal_b" />';
			document.getElementById("card").innerHTML = card;
			var ansButton = document.getElementById('reveal_b');
			ansButton.addEventListener("click",revealAnswer);
			document.getElementById("reveal_b").focus();
			parentSandboxBridge.trace("makeCard: focus");
			*/
		}
	
		
	}else if(cardType == 1){
		card += "<h2 class='question'>"+q.question+"</h2>";
		//RETENTION CARD!
		//parentSandboxBridge.trace("cardType is reten");
		cardState = "question-reten";
	   //var  retenHTML =  '<form id="reten_form">';
		card += '<input type="text" id="answer_txt"/>';
		card += '<input type="submit" value="go" id="go_sub"/>';
		//retenHTML += '</form>';
		
		//test to display message
		var specChar = containsSpecialChar();
		if(specChar){
			card += '<p class="specCharsMessage">(&#225;, &#241;, !, etc. not required)</p>';
		}
		
		if(q.img_name != ''  && typeof q.img_name != 'undefined'){
			card += "	</div>";
			card += "	<br style='clear:both' />";
			card += "</div>";
		}
	
		
		document.getElementById("card").innerHTML = card;
		
		if(q.img_name != ''  && typeof q.img_name != 'undefined'){
			var imageThumb = document.getElementById('image_thumb');
			imageThumb.addEventListener("click",showLargeImage);
		}
		
		var go_b = document.getElementById("go_sub");
		go_b.addEventListener('click',submitAnswer);
		/*
		var retenForm = document.getElementById("reten_form");
		//retenForm.addEventListener('onSubmit',submitAnswer);
		retenForm.action = submitAnswer;
		retenForm.onSubmit = submitAnswer;
		*/
		document.getElementById("answer_txt").focus();
		parentSandboxBridge.trace("makeCard: focus");
	}
	
		
	
	setPopTools();
	setCopyright();
}

function hidePopling(){
	parentSandboxBridge.hider();
}

function revealAnswer(){
	//used by 1st state of flash card only.
	
	var q = retrievedCard.q;
	
	cardState = "question-show-answer";
	var card = "";
	
	
	if(q.img_name != ''  && typeof q.img_name != 'undefined'){
		
		var i_thb_url = remoteUrl +"q_images/"+ q.img_name +"_thmb."+q.img_ext+"?p="+Math.floor(Math.random()*11);
		
		card += "<div>";
		card += "	<div class='imageContain'>";
		card += "		<img src="+i_thb_url+" id='image_thumb'  border='1' />";
		card += "	</div>";
		card += "	<div  class='imageCardContain'>";
		
		//parentSandboxBridge.trace("i_thb_url: "+i_thb_url);
	}
	
	
	card += "<h2 class='question'>"+ q.question +" = <span class='correct'>"+ q.correct +"</span></h2>";
	card += "<p>"+ q.notes +"</p>";
	
	card += '<input class="button_a" type="button" value="Next Card" id="getCardB">';
	card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';
	
	if(q.img_name != ''  && typeof q.img_name != 'undefined'){
		card += "	</div>";
		card += "	<br style='clear:both' />";
		card += "</div>";
	}


	document.getElementById("card").innerHTML = card;
	
	//IMAGE action
	if(q.img_name != ''  && typeof q.img_name != 'undefined'){
		var imageThumb = document.getElementById('image_thumb');
		imageThumb.addEventListener("click",showLargeImage);
	}
	
			
			
	var h = document.getElementById('hiderButton');
	
	document.getElementById('getCardB').focus();
	h.addEventListener("click", hidePopling);
	
	var g = document.getElementById('getCardB');
	g.addEventListener("click",getCard);
	submitScore(2,0);
}

function diffString(o1,n1) { //o1=correct n1=userAnswer

	var o = removePunctuation(o1,1,1);
	//parentSandboxBridge.trace("o: " + o);	
	o = o.split('');
	
	var n = removePunctuation(n1,1,1);
	//parentSandboxBridge.trace("n: " + n);	
	n = n.split('');
	
	var m = n1.split('');
	
	var incorrect = new Array();
	
	
	//go through forwards
 	for(i in o){	
		//var oldChar =  replaceSingleChar(o[i],0);
		//parentSandboxBridge.trace('DIFF: n='+n[i]);
		
		if(typeof n[i] != 'undefined'){
			//get the transliteration of the answer character
			//var newChar =  replaceSingleChar(n[i],0);
			//match?
			if(o[i] != n[i]){
				incorrect.push(i);
			}
		}
	}	
	
	
	//go through backwards
	for (i=o.length;i>=0;i--){
	//parentSandboxBridge.trace("backwards i: "+i);
		
		//var oldChar =  replaceSingleChar(o[i],0);
			if(typeof n[i] != 'undefined'){
			//get the transliteration of the answer character
				//var newChar =  replaceSingleChar(n[i],0);
				//match?
				
				if(o[i] != n[i]){
					//parentSandboxBridge.trace("backwards incorrect: "+i);
					incorrect.push(i);
				}else{
					//the letter is correct backwards, remove from forwards incorrect if present
					for(a in incorrect){
						if(incorrect[a] == i){
							//parentSandboxBridge.trace("found in forwards incorrect, removing");
							//parentSandboxBridge.trace("incorrect b4: "+incorrect);
							incorrect.splice(a,1);
							//parentSandboxBridge.trace("incorrect after: "+incorrect);
							
						}	
					}
				}
			}
		}

	for(x in incorrect){
		var s =incorrect[x];
		var l = "<span>"+ m[s] +"</span>";
		//parentSandboxBridge.trace(l);
		m[s] = l;
		
	}
	
	
	return  m.join(''); //make it a string again.
}

function diffString2(o1,n1) { //o1=correct n1=userAnswer
	
	var o = o1.split('');
	
	var n = n1.split('');
	
	var m = n1.split('');
	
	var edit = false;
	
 	for(i in o){
		var oldChar =  replaceSingleChar(o[i],0);
		//parentSandboxBridge.trace('DIFF: n='+n[i]);
		
		if(typeof n[i] == 'undefined'){ //if n[i] is undefined, n is shorter, append a blank
			//parentSandboxBridge.trace('DIFF: SHORTER, BREAKING');
			m.splice(m.length,0,"<span>&nbsp;&nbsp;&nbsp;</span>");
		}else{
			var newChar =  replaceSingleChar(n[i],0);
			
			if(oldChar != newChar){
				m.splice(i,0,"<span>");
				edit = true;
			}
		
			if(n.length > o.length){ //if longer
				m.splice(o.length,0,"<span>");
				edit = true;
			}
			
			//if an edit has been made, close it.
			if(edit){
				m.splice(m.length,0,"</span>");
				edit = false;
			}
		}
			
	}	
	
	return  m.join(''); //make it a string again.
}

function submitAnswer(){
	
	var q = retrievedCard.q;
	
	var userAnswer = document.getElementById("answer_txt").value;
	
	//parentSandboxBridge.trace("submitAnswer: "+userAnswer);
	
	var c = removePunctuation(q.correct,1);
	var a = removePunctuation(userAnswer,0);
	
	//parentSandboxBridge.trace("submitting answer");
	
	var card = "";
	
	if(q.img_name != '' && typeof q.img_name != "undefined"){
		
		var i_thb_url = remoteUrl +"q_images/"+ q.img_name +"_thmb."+q.img_ext+"?p="+Math.floor(Math.random()*11);
		
		card += "<div>";
		card += "	<div class='imageContain'>";
		card += "		<img src="+i_thb_url+" id='image_thumb'  border='1' />";
		card += "	</div>";
		card += "	<div  class='imageCardContain'>";
		
		//parentSandboxBridge.trace("i_thb_url: "+i_thb_url);
	}

	
	if(a == c){
		var answer = 1;
		card += "<h1><img src='assets/images/correct.gif'  align='absmiddle' />&nbsp;Correct</h1>";
		card += "<h2  class='question'>"+ q.question +" = "+ q.correct +"</h2>";
	}else{
		var answer = 0;
		
		var userAnswerDisp;
		if(userAnswer == ''){
			userAnswerDisp = '______';
		}else{
			userAnswerDisp = diffString(q.correct,userAnswer);
			//parentSandboxBridge.trace("userAnswerDisp: "+userAnswerDisp);
		}
		
		card += "<h1 class='incorrect'><img src='assets/images/incorrect.gif' align='absmiddle' /><strong><em>" + userAnswerDisp + "</em></strong> is Incorrect</h1>";
		//card += userAnswerDisp +" is incorrect";
		card += "<h2  class='question'>"+ q.question +" = "+ q.correct +"</h2>";	
	}
	
	if(q.notes != ""){
			card += "<h4 class='notes'>"+  q.notes +"</h4>";
		}
	if(answer == 1){
		//parentSandboxBridge.trace("creating correct buttons");
		card += '<input class="button_a" type="button" value="Next Card" id="getCardB">';
		card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';

		if(q.img_name != ''  && typeof q.img_name != 'undefined'){
			card += "	</div>";
			card += "	<br style='clear:both' />";
			card += "</div>";
		}
	
	
		document.getElementById("card").innerHTML = card;
		
		
			
		//IMAGE action
		if(q.img_name != ''  && typeof q.img_name != 'undefined'){
			parentSandboxBridge.trace("creating image link: ");
			var imageThumb = document.getElementById('image_thumb');
			imageThumb.addEventListener("click",showLargeImage);
		}

			
		var h = document.getElementById('hiderButton');
		h.addEventListener("click", hidePopling);
		
		var g = document.getElementById('getCardB');
		g.addEventListener("click",getCard);
		
		
		document.getElementById("getCardB").focus();
	}else{
		
		card += '<input class="button_a" type="button" value="Try Again" id="tryAgainB">';
		card += '<input class="button_a" type="button" value="Skip" id="skipB">';
		card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';
		
		
		if(q.img_name != ''  && typeof q.img_name != 'undefined'){
			card += "	</div>";
			card += "	<br style='clear:both' />";
			card += "</div>";
		}
		
		
		document.getElementById("card").innerHTML = card;
			
		
		var h = document.getElementById('hiderButton');
		h.addEventListener("click", hidePopling);
		
		var s = document.getElementById('skipB');
		s.addEventListener("click",skipCard);
		
		var g = document.getElementById('tryAgainB');
		g.addEventListener("click",makeCard);
		
		document.getElementById("tryAgainB").focus();
	}

	//for keypress event:
	cardState = "answered";
	submitScore(answer,0);
}


function submitScore(answer,skipReten,getNewCard){
	
	if(typeof getNewCard != 'undefined'){
		displayGettingMessage();
	}
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	//reset title and question for notify window
	cardIsAnswered = true;
	//resetRetrievedCard();
	
	//update status
	parentSandboxBridge.trace("score being submitted" + answer + " skipReten:" +skipReten);
	
	var u = remoteUrl + "air/score.php";
	var d = "popling_id="+p.popling_id;
	d += "&q_id="+q.q_id;
	d += "&u="+username;
	d += "&p="+MD5(password);
	d += "&answer="+String(answer);
	
	if(skipReten == 1){
		url += "&skipReten=1";
	}
	
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			
			var r = JSON.parse(data);
			if(r.result == "1"){
				//update status
				var status = "score submitted";
				if(getNewCard == true){
					getCard();
				}
			}else{
				//update status
				var status = "error sumitting score";
			}
			
	   }, error: ajax_timeout_error

	 });
	
	
}

function skipCard(){
	parentSandboxBridge.trace("skipping card");
	
	displayGettingMessage();
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	cardIsAnswered = true;
	//resetRetrievedCard();
	
	var u = remoteUrl + "air/score.php";
	var passMd5 = MD5(password);
	
	var d = "popling_id="+p.popling_id;

	d += "&q_id="+q.q_id;
	d += "&skipReten=1";
	d += "&u="+username;
	d += "&p="+passMd5;
	
	
	$.ajax({
	   type: "GET",
	   url: u,
	   data: d,
	   timeout:global_timeout,
	   success: function(data){
			
			var r = JSON.parse(data);
			if(r.result == "1"){
				//update status
				var status = "card skipped";
			}else{
				//update status
				var status = "error skipping card";
			}
			//parentSandboxBridge.trace(status);
			getCard();
			
	   },  error: ajax_timeout_error

	 });
	
 
}

function parseUri (str) {
	var	o   = {
	strictMode: false,
	key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
	q:   {
		name:   "queryKey",
		parser: /(?:^|&)([^&=]*)=?([^&]*)/g
	},
	parser: {
		strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
		loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
	}
};
	var m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str);
	var uri = {};
	var i   = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};


