var widthChangeMemInt;
var main_width = 500;
var main_height = 400;

var notify_width = 300;
var notify_height = 120;

var taskbar_height;

$( document ).ready( function() {
							  
	//UI specific INIT functions
		
	$( '#minimize' ).click( function() {
		hideChrome();	
	} );		

	$( '#close' ).click( function() {
		window.nativeWindow.close();							  
	} );
	
	$( '#hide_button' ).click( function() {
		if(notifyTimer != null){
			if(notifyTimer.running == true){
				hideNotify();
			}else{
				hider();
			}
		}else{
			hider();
		}
	} );
	
	$('#hide_button').tooltip({showURL: false, positionLeft: true, left:20});
	$('#mainButtons button').tooltip({showURL: false, positionLeft: true }); 
} );

function changeClass(c){
	trace('changeClass ' + c);
	$('body').removeClass();
	$('body').addClass(c);
}

function getTaskBarHeight(){ //WINDOWS
	//var p = air.NativeWindow.maxSize;
	var s = air.NativeWindow.systemMaxSize;
	//var screenBounds = air.Screen.mainScreen.bounds;
	//trace("getTaskBarHeight: " + screenBounds.bottom);
	//return parseInt(screenBounds.bottom);
}

function setChromeToNotifyWindow(){
	//trace("setChromeToNotifyWindow");
	
	$('#header').hide();
	$('#full_canvas').hide();
	
	window.nativeWindow.width = notify_width;
	window.nativeWindow.height = notify_height;
	
	setWindowPosition();
	
	$('#notify_canvas').show();
	showChrome();
	bringToFront('notify');
	notifyWindow = true;
}

function hideChrome(){
	//trace("hideChrome");
	window.nativeWindow.visible = false;
}

function showChrome(){
	//trace("showChrome");
	window.nativeWindow.visible = true;
}

function makeFull(){ //make full is called first by show
	//trace("makeFull");	

	notifyWindow = false;
	
	$('#notify_canvas').hide();
	$('#header').hide();
	$('#full_canvas').hide();
	
	doWidthChange();

	setWindowPosition();
	$('#full_canvas').show();
	
}


function doWidthChange() {  //called by makeFull
   //trace("doWidthChange");	
	
	if(notifyWindow){
		window.nativeWindow.width = notify_width;
		window.nativeWindow.height = notify_height;
	}else{
		window.nativeWindow.width = main_width;
		window.nativeWindow.height = main_height;
	}
	
	displayFullCanvas();
}

function easeInOut(minValue,maxValue,totalSteps,actualStep,powr) { //called by doWidthChange
	//Generic Animation Step Value Generator By www.hesido.com 
    var delta = maxValue - minValue; 
    var stepp = minValue+(Math.pow(((1 / totalSteps) * actualStep), powr) * delta); 
    return Math.ceil(stepp);
}



function setWindowPosition(){
	trace("setWindowPosition");
	
	var wp = poplingPrefs['notifyPos'];
	
	trace("setWindowPosition"+ wp);
	
	var offset = new Array();
	if(air.NativeApplication.supportsDockIcon){
		offset = {0:20,1:0,2:0,3:0};//bottom right,bottom left,top right,top left
	}else{
		offset = {0:0,1:0,2:0,3:20};//bottom right,bottom left,top right,top left
	}
	
	$("#chrome").removeClass();
	$("#full_canvas").removeClass();
	$("#full_canvas").removeClass();
	$("#hide_button").removeClass();
	
	
	if(wp == 0){ //bottom right
		window.nativeWindow.x =	air.Capabilities.screenResolutionX - window.nativeWindow.width;
		window.nativeWindow.y = air.Capabilities.screenResolutionY - window.nativeWindow.height;
		$("#chrome").addClass('chrome_bottomright');
		$("#full_canvas").addClass('full_bottomright');
		$("#hide_button").addClass('hideB_bottomright');
		trace("		setWindowPosition: bottom right "+ $("#chrome").attr('class'));
	}else if(wp == 1){ //bottom left
		window.nativeWindow.x = 0;
		window.nativeWindow.y = air.Capabilities.screenResolutionY - window.nativeWindow.height;
		$("#chrome").addClass('chrome_bottomleft');
		$("#full_canvas").addClass('full_bottomleft');
		$("#hide_button").addClass('hideB_bottomleft');
		trace("		setWindowPosition: botom left "+ $("#chrome").attr('class'));
		
	}else if(wp == 2){ //top right
		window.nativeWindow.x =air.Capabilities.screenResolutionX - window.nativeWindow.width;
		window.nativeWindow.y = offset[0];
		$("#chrome").addClass('chrome_topright');
		$("#full_canvas").addClass('full_topright');
		$("#hide_button").addClass('hideB_topright');
		trace("		setWindowPosition: topRight"+ $("#chrome").attr('class'));
	}else if(wp == 3){ //top left
		window.nativeWindow.x = 0;
		window.nativeWindow.y = offset[0];
		
		$("#chrome").addClass('chrome_topleft');
    	$("#full_canvas").addClass('full_topleft');
		$("#hide_button").addClass('hideB_topleft');
		trace("		setWindowPosition: topLeft"+  $("#chrome").attr('class'));
	}
	showChrome();
}

function displayFullCanvas(){
	//trace("displayFullCanvas");
	$('#full_canvas').show();
	$('#header').show();
	/*
	if(typeof getAuxContent == 'function'){
		getAuxContent();
	}else{
		trace("getAuxContent: "+typeof getAuxContent);
	}
	*/
}

//////////////////////////////////////////
//WINDOW LISTENERS 
//////////////////////////////////////////

function onDeactivate() { 
	//trace("window deactivated");
	startTimer();// On deactivate, start timer
};

function onActivate() { 

		clearTimer();
		
		//refreshCard();
		
		if(hiddenSatus == true){
			hiddenSatus = false;
		}
	
};

function cleanUp(){
	//clearTimer();
	//window.nativeWindow.removeEventListener(air.Event.CLOSING, cleanUp);
	
	window.nativeWindow.removeEventListener(air.Event.DEACTIVATE, onDeactivate);
	window.nativeWindow.removeEventListener(air.Event.ACTIVATE, onActivate);
	window.nativeWindow.removeEventListener(air.Event.ACTIVATE, onActivate);
	window.nativeWindow.removeEventListener(air.Event.CLOSING, showCloseWarning);
	
	clearTimer();
	clearNotifyTimer();
	
	coreTimer = null;
	notifyTimer = null;
	
}

function showCloseWarning(){

	var displayCloseWarning = poplingPrefs['skipCloseDialog'];
	trace("displayCloseWarning: " + String(displayCloseWarning));
	if(displayCloseWarning == '0' || displayCloseWarning == 0 ){
		navToTab('confirm');
	}else{
		closeWindow();	
	}
}

function closeWindow(){
	window.nativeWindow.close()
}

function dockSystrayInvoke(){
	////////////////////
	// DOCK ICON vs. SYSTEM TRAY
	////////////////////
	if(air.NativeApplication.supportsDockIcon){ 
		//mac dock icon click
		air.NativeApplication.nativeApplication.addEventListener(air.InvokeEvent.INVOKE, onInvoke);
	}else{
		//win system tray click
		var iconLoadComplete = function(event) { 
			air.NativeApplication.nativeApplication.icon.bitmaps = new runtime.Array(event.target.content.bitmapData); 
		} 
		 
		//air.NativeApplication.nativeApplication.autoExit = false; 
		var iconLoad = new air.Loader(); 
		var iconMenu = new air.NativeMenu(); 
		var exitCommand = iconMenu.addItem(new air.NativeMenuItem("Exit Popling")); 
		exitCommand.addEventListener(air.Event.SELECT,function(event){ 
				air.NativeApplication.nativeApplication.icon.bitmaps = []; 
				air.NativeApplication.nativeApplication.exit(); 
		}); 
	
	
		iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE,iconLoadComplete); 
		iconLoad.load(new air.URLRequest("air_icons/air_16.png")); 
		air.NativeApplication.nativeApplication.icon.tooltip = "Click To Pop";
		air.NativeApplication.nativeApplication.icon.addEventListener('click',onSysTrayClick);
	}
}

function onInvoke(invocation){
	//trace("onInvoke: "+invocation);
   	//var arguments = invocation.arguments; 
	if(hasRun){
		showFullWindow();
	}
	hasRun = true;
}



function createWindowListeners(){
	//trace("creating window listeners");
	//create listeners for when window is focused and pushed to background
	window.nativeWindow.addEventListener(air.Event.DEACTIVATE, onDeactivate);
	window.nativeWindow.addEventListener(air.Event.ACTIVATE, onActivate);
	window.nativeWindow.addEventListener(air.Event.CLOSING, showCloseWarning);
	//dockSystrayInvoke();
	
}