// JavaScript Document
var checkForUpdates = true;
var appState = true;
var hiddenSatus = false;
var coreTimer = null;
var timerFunction = notify;

var hasRun = null;

//mouse functions
var mX;
var mY;

function turnOn(){
	appState = true;
	startTimer();
	createWindowListeners();
}

function turnOff(){
	trace('turn off');
	appState = false;
	cleanUp();
}


function toggleOnOff(){
	if(appState){
		//trace('Stopping Popling');
		$("#onOff").addClass("onB");
		$("#onOff").removeClass("offB");
		$("#onOff").attr("title","Turn Popling On");
		turnOff();
		$('#onOff').tooltip({showURL: false});
	}else{
		//trace('Starting Popling');
		$("#onOff").addClass("offB");
		$("#onOff").removeClass("onB");
		$("#onOff").attr("title","Turn Popling Off");
		turnOn();
		$('#onOff').tooltip({showURL: false});
	}
}



function onSysTrayClick(){
	trace("onSysTrayClick");
	showFullWindow();

}

/*EXTERNAL LINKING*/

function linkToPage(href){
	//trace("link to page");
	var r = new air.URLRequest(href);
	air.navigateToURL(r);
}

function loadURLAndReturnVars (url){
	//trace("loadURLAndReturnVars"+url);
	var request = new air.URLRequest(url); 
	var loader = new air.URLLoader(); 
	return loader.load(request);
}

function getRemoteURL(){
	return remoteUrl;
}



function keyPressEvent(e){
	if(e.keyCode == 119 && e.metaKey || e.keyCode == 119 && e.ctrlKey){
		hider();
	}
}

document.onkeypress=keyPressEvent;

///////////////////////////////////////////////////////
///////// SHOW AND HIDE EVENTS 
///////////////////////////////////////////////////////

function hider(){
	trace("hider");
	
	var currentTab = getCurrentTab();
	if(currentTab != 'cards'){
		navToTab('cards');
	}
	
	clearCard();
	
	
	hiddenSatus = true;

	hideChrome();
	
}


function showFullWindow(){
	trace("Show Full Window: coreTimer:"+String(coreTimer));
	
	if(coreTimer != null){
		if(coreTimer.running){
			clearTimer();
		}	
	}
	
	trace("showFullWindow: notifyTimer:"+String(notifyTimer));
	
	if(notifyTimer != null){
		if(notifyTimer.running){
			trace("notify timer is running");
		//if(poplingPrefs['teaser'] == "true"){
			clearNotifyTimer();
		}
	}
	
	makeFull();
	
	showChrome();
	bringToFront();
	refreshCard();	
	

	
}

function showFullWindowDock(){
	trace("Show Full Window poplingPrefs['teaser']:"+poplingPrefs['teaser']);
	//clearTimer();
	clearNotifyTimer();
	bringToFront();
	showChrome();
	makeFull();
	refreshCard();
}



function bringToFront(notify){
	trace("bringToFront");
	//brings card window to front from minimized
	
	//window.nativeWindow.activate();
	//window.nativeWindow.orderToFront();
	window.nativeWindow.alwaysInFront = true;
	
	if(notify != 'notify'){ //unset for main window
		window.nativeWindow.alwaysInFront = false;	
	}
	
	
	if(typeof getAuxContent == 'function'){
		getAuxContent();
	}else{
		trace("getAuxContent: "+typeof getAuxContent);
	}
}


function startTimer(){
	trace("Start Timer");
	
	//test connection before starting timer
	if(conn == true && appState == true){	
	
		//get pop time preference or set
		if(typeof poplingPrefs['popTime'] == 'undefined'){
			poplingPrefs['popTime'] = 5;	
		}
		var p = (poplingPrefs['popTime']*60) * 1000;
		
		var timerFunction;
		
		if(poplingPrefs['teaser'] == "true"){
			timerFunction = notify;
		}else{
			timerFunction = showFullWindow;
		}
		
		if(coreTimer == null){
			coreTimer = new air.Timer(p, 0);
			coreTimer.addEventListener(air.TimerEvent.TIMER,timerFunction); //eigher notify or 
		}
		
		coreTimer.start();
	}
	
}

function clearTimer(){
	trace("clearTimer");
	
	if(coreTimer != null){
		coreTimer.reset();
	}
	
	clearNotifyTimer();
}

function refreshCard(){
	trace("refreshCard");
	
	var retrievedCard = getRetrievedCard();
	
	if(retrievedCard != null){
		makeRetrievedCard();
	}else{
		getCard();
	}
}

