// JavaScript Document


function displayNewFeatures(){
	parentSandboxBridge.trace("displayNewFeatures");
	var card = "<h1>Upgrade Successful</h1>";
	card += "<div class='borderedContainer standard_copy_size'>"
	card += "<h2>New Features In This Release</h2>";
	card += features;
	card += "</div>";
	card += "<br class='clearBoth' />";
	card += "<div id='prefsActions'>";
	card += "<input type='button' class='button_a' id='continueButton' value='Continue' />";
	document.getElementById("message_contain").innerHTML = card;
	var g = document.getElementById("continueButton");
	g.addEventListener('click',continueFromFeatures);
}


function displayUserPassWarning(){ 
		var em = "<p>Your username and password must match your popling.net account settings.<br />";
		em += "If your password is correct, try <strong><a href='#' id='resetPass'>resetting it</a></strong>, if that doesn't work <a href='#' id='getSupport'>contact support</a>.</p>";
		document.getElementById("message").innerHTML = em;
		//document.getElementById('message').style.display = "block";
		$('#message').addClass('errorMessage').show('slow');
		
		var g = document.getElementById("getSupport");
		g.addEventListener('click',contactPopling);
		
		var g = document.getElementById("resetPass");
		g.addEventListener('click',resetPassLink);
}

function refreshPopling(){
	parent.window.location = "root.html";
}

function displayOfflineMessage(){
	parentSandboxBridge.trace("displayOfflineMessage");
	navToTab('offlineMessage');
}



function displayVersionCheckMessage(){
	parentSandboxBridge.trace(displayVersionCheckMessage);
	var content = "<h1>Initializing</h1>";
	content += "<div class='borderedContainer'>";
	content += "<p><img src='assets/images/loader.gif' alt='loader' width='32' height='32' align='absmiddle' /> Looking for new versions.</p>";
	content += "</div>";
	
	$("#message_contain").html(content);
	
}

function displayUpgradeMessage(features){
	parentSandboxBridge.trace('displayUpgradeMessage');
	var content = "<h1>Initializing</h1>";
	content += "<div class='centeredCard'>";
	content += "<div>";
	content += "<h2><img src='assets/images/alert.png' align='absmiddle'/>There is an update to Popling available.<h2>";
	content += "<div id='update_mess'>";
	content += "<h3><button href='#' class='button_a' id='getUpdateLink'>Install Upgrade</button></h3>";
	content += "</div>";
	content += "</div>";
	content += "</div>";
	$("#message_contain").html(content);
	document.getElementById('getUpdateLink').addEventListener("click",getUpdate);
	
}

function signUpLink(){
	var url="http://www.popling.net/signup";
	parentSandboxBridge.linkToPage(url);
}


function displayNewUserMessage(){
	parentSandboxBridge.trace("displayNewUserMessage");
	var signupURL = "http://popling.net/signup/";
	var frm = '<p>Welcome to Popling, enter your username and password to get started.<br />';
	frm += '<strong>If you do not have an account, ';
	frm += '<a href="#" class="exLink" id="signUpLink">sign up here</a>.</strong></p>';
	
	document.getElementById('message').innerHTML = frm;
	document.getElementById('message').style.display = "block";
	$('#message').addClass('warnMessage').show('slow');
	document.getElementById('signUpLink').addEventListener('click',signUpLink);
}


function userNamePassError(){
	navToTab('prefs');
	var signupURL = "http://popling.net/signup/";
	var frm = '<p>A Popling username and password are required.<br />';
	frm += '<strong>You can <a href="#" class="exLink" id="signUpLink">sign up here</a></strong>, for free!</p>';
	
	document.getElementById('message').innerHTML = frm;
	document.getElementById('message').style.display = "block";
	
	
	document.getElementById('message').style = "errorMessage";
	
	document.getElementById('signUpLink').addEventListener('click',signUpLink);
}