
var notifyTimer = null;
var notifySeconds = 10 * 1000;
var notifyWindow = null;
var notifyOptions = new air.NativeWindowInitOptions();
	notifyOptions.systemChrome = air.NativeWindowSystemChrome.NONE;
	notifyOptions.type = "lightweight";
	notifyOptions.transparent=true;

//for notify window pos
var win_y;
var win_x;
var wb;
var wr;
	

function notify(){
	trace("notify");
	
	clearTimer();
	var retrievedCard = getRetrievedCard();
	if(retrievedCard == null){
		getCard(true);
	}else{
		renderNotifyWindow();
	}
	
}

function hideNotify(){
	trace("hideNotify");
	
	clearNotifyTimer();
	
	window.nativeWindow.alwaysInFront = false;
	window.nativeWindow.orderToBack();
	
	hideChrome();
	startTimer();
}

function renderNotifyWindow(){
	trace("renderNotifyWindow");
	
		
	setChromeToNotifyWindow();
	
	var rc = getRetrievedCard();
	var notifyTitle = rc.p.name;
	var notifyQuestion = rc.q.question;
	injectMessage(notifyTitle, notifyQuestion);
	
	//SET NOTIFY TIMER
	if(notifyTimer == null){
		notifyTimer = new air.Timer(notifySeconds, 0);
		notifyTimer.addEventListener(air.TimerEvent.TIMER,hideNotify);
	}
	notifyTimer.start();
}

function clearNotifyTimer(){
	trace("clearNotifyTimer"+ String(notifyTimer));
	if(notifyTimer != null){
		notifyTimer.reset();
	}
}

function injectMessage(notifyTitle, notifyQuestion){
	trace("injectMessage: " + notifyTitle);
	
	var l = notifyQuestion.length;
	if(l > 60){
		notifyQuestion = notifyQuestion.substr(0,60);
		notifyQuestion += "...";
		trace(notifyQuestion);
	}
	
	$("#notify_title").html(notifyTitle);
	$("#notify_question").html(notifyQuestion + "&nbsp;=&nbsp;______&nbsp;?");
	
}

/*

function closeNotify(){
	try{
		notifyWindow.window.close();
	}catch(error){
		trace(error);
		$("#app_mess").val(error);
	}

	clearNotifyTimer();
	
}

*/