
///////////////////////////////////////
// PREFERENCES UI
//////////////////////////////////////


var prefs_sb;

function setStyle(m){
	
	var s = m.selectedIndex; 
	var c = m.options[s].value;
	
	parentSandboxBridge.changeClass(c);
	
	$('body').removeClass();
	$('body').addClass(c);
	
}


function renderPreferences(){
	parentSandboxBridge.trace("renderPreferences" + prefs_sb);
	
	var version = parentSandboxBridge.getThisVersion();
	
	
	if(typeof prefs_sb != "object"){	
		displayNewUserMessage();
	}else{
		prefs_sb = parentSandboxBridge.getPrefs();
	}
	
	$('#version_disp').html(version);
	
	if(prefs_sb['name'] != ''){
		$('#p_username').val(prefs_sb['name']);
	}
	
	if(prefs_sb['skipCloseDialog'] != ''){
		$('#p_skipCloseDialog').val(prefs_sb['skipCloseDialog']);
	}
	
	//parentSandboxBridge.trace("style pref:: " +prefs_sb['p_style']);
	
	
	parentSandboxBridge.trace("prefs_sb['p_style']: " + prefs_sb['style']);
	
	if(typeof prefs_sb['style'] != "undefined" ){
		$('#p_style').val(prefs_sb['style']);
	}
	
	if(parentSandboxBridge.getPass()){
		$('#p_password').val(parentSandboxBridge.getPass());
	}
	
	$('#p_popTime').val(prefs_sb['popTime']);
	if(prefs_sb['teaser'] == "true"){
		var t = 'checked';
	}else{
		var t = '';
	}
	$('#p_teaser').attr('checked',t); 
	
	
	
	
	var wp = prefs_sb['notifyPos'];
	parentSandboxBridge.trace("renderPreferences window position: " + wp);
	document.getElementById('p_notify_pos').selectedIndex = wp; 
	
	//run at startup
	var runAtStart = parentSandboxBridge.getRunAtStartup();
	parentSandboxBridge.trace("renderPreferences runAtStart: "+runAtStart);
	
	if(runAtStart == "undefined"){
		runAtStart = true;
	}
	
	document.getElementById('p_startup').checked = runAtStart;
	
}

function savePrefs(refreshRoot){
	parentSandboxBridge.trace("savePrefs from index.html"+String(refreshRoot));
	
	//set prefs in XML
	prefsArray = new Array();
	d = document.getElementById;
	
	var pass = document.getElementById('p_password').value;
	var un = document.getElementById('p_username').value;
	
	prefsArray['name'] = un;
	prefsArray['password'] =  pass;
	
	prefsArray['runAtStartUp'] = document.getElementById('p_startup').checked;
	
	prefsArray['skipCloseDialog'] = document.getElementById('p_skipCloseDialog').value;
	prefsArray['popTime'] = document.getElementById('p_popTime').value;
	prefsArray['teaser'] = document.getElementById('p_teaser').checked;
	prefsArray['notifyPos'] = document.getElementById('p_notify_pos').selectedIndex;
	prefsArray['style'] = document.getElementById('p_style').value;
	
	parentSandboxBridge.trace("saveing style "+prefsArray['style'] );
	if(prefsArray['password'] != '' && prefsArray['name'] != ''){
		//all set, setting prefs
		parentSandboxBridge.setPrefs(prefsArray,refreshRoot);
	}else{
		parentSandboxBridge.trace("user or pass not set");
		userNamePassError();
	}	
	
}

function cancelPrefs(){
	//if username and password are not set, don't go to cards
	var d = document.getElementById;
	var pass = document.getElementById('p_password').value;
	var un = document.getElementById('p_username').value;
	if(pass != '' && un != ''){
		navToTab('cards');
	}else{
		userNamePassError();
	}
}

function poplingLink(){
	var url = "http://www.popling.net";
	parentSandboxBridge.linkToPage(url);
}